package me.goosemonkey.NoSpawnEggsV2;

import java.util.Arrays;

import me.goosemonkey.NoSpawnEggsV2.NoSpawnEggs.PluginVersion;

import org.bukkit.plugin.java.JavaPlugin;

public class ConfigMain extends ConfigAbstract
{
	public ConfigMain(JavaPlugin inst)
	{
		super(inst);
	}

	@Override
	public String getHeader()
	{
		return "\n" +
				"Full config help: http://tinyurl.com/nseconfig/" +
				"\n\nConfigure the plugin here. Only options based on the\n" +
				"version you choose will be shown below.\n\n" +
				"** Commonly Used Options:\n" +
				"enable: Enables the option shown\n" +
				"onlyBlockCreative: If true, players in survival mode will always bypass this block.\n" +
				"ignoredWorlds: Players in these worlds will bypass this block.\n\n" +
				"** Specific options:\n" +
				"spawnEggs: Allow or deny the use of Spawner Eggs (ID 383).\n" +
				"  * Block is determined by the setting in this order:\n" +
				"    1. Per world blocked IDs\n" +
				"    2. Per world allowed IDs\n" +
				"    3. Per world group settings\n" +
				"    4. Global ($global) blocked IDs\n" +
				"    5. Global allowed IDs\n" +
				"    6. Global group settings\n" +
				"    7. Permissions\n" +
				"golem: Blocks the building of Snow and Iron Golems\n" +
				"chickenEgg: Blocks spawning chickens from eggs\n" +
				"  sendMessage: Tells the thrower that their egg throwing is pointless\n" +
				"expBottle: Blocks throwing Bottles o' Enchanting\n" +
				"enderEye: Eyes of Ender\n" +
				"enderPearl: Ender pearls\n" +
				"boat / minecart: Boats and minecarts (all types)\n" +
				"dispense: Prevents these items from launching from dispensers";
	}

	@Override
	public void setDefaultValues()
	{
		this.checkSet("configVersion", 2, PluginVersion.LIGHT);
		
		
		this.checkSet("blocking.spawnEggs.enable", true, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.onlyBlockCreative", false, PluginVersion.LIGHT);
		
		this.checkSet("blocking.spawnEggs.$global.animal", true, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.$global.monster", true, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.$global.npc", true, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.$global.unknown", true, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.$global.blockedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.$global.allowedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		
		this.checkSet("blocking.spawnEggs.ExampleWorld.animal", false, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.ExampleWorld.npc", false, PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.ExampleWorld.blockedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		this.checkSet("blocking.spawnEggs.ExampleWorld.allowedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);

		
		this.checkSet("blocking.golem.enable", true, PluginVersion.MODERATE);
		
		this.checkSet("blocking.golem.snow.onlyBlockCreative", false, PluginVersion.MODERATE);
		this.checkSet("blocking.golem.snow.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.MODERATE);
		
		this.checkSet("blocking.golem.iron.onlyBlockCreative", false, PluginVersion.MODERATE);
		this.checkSet("blocking.golem.iron.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.MODERATE);
		
		
		this.checkSet("blocking.chickenEgg.enable", true, PluginVersion.MODERATE);
		
		this.checkSet("blocking.chickenEgg.onlyBlockCreative", false, PluginVersion.MODERATE);
		this.checkSet("blocking.chickenEgg.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.MODERATE);
		this.checkSet("blocking.chickenEgg.sendMessage", true, PluginVersion.MODERATE);
		
		
		this.checkSet("blocking.expBottle.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.expBottle.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
		this.checkSet("blocking.expBottle.onlyBlockCreative", false, PluginVersion.FULL);
		
		this.checkSet("blocking.enderEye.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.enderEye.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
		this.checkSet("blocking.enderEye.onlyBlockCreative", false, PluginVersion.FULL);

		this.checkSet("blocking.enderPearl.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.enderPearl.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
		this.checkSet("blocking.enderPearl.onlyBlockCreative", false, PluginVersion.FULL);

		this.checkSet("blocking.boat.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.boat.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
		this.checkSet("blocking.boat.onlyBlockCreative", false, PluginVersion.FULL);

		this.checkSet("blocking.minecart.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.minecart.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
		this.checkSet("blocking.minecart.onlyBlockCreative", false, PluginVersion.FULL);
		
		
		this.checkSet("blocking.dispense.spawnEggs.enable", true, PluginVersion.LIGHT);
		
		this.checkSet("blocking.dispense.spawnEggs.$global.animal", true, PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.$global.monster", true, PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.$global.npc", true, PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.$global.unknown", true, PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.$global.blockedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.$global.allowedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		
		this.checkSet("blocking.dispense.spawnEggs.ExampleWorld.animal", false, PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.ExampleWorld.npc", false, PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.ExampleWorld.blockedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		this.checkSet("blocking.dispense.spawnEggs.ExampleWorld.allowedIds", Arrays.asList(new Integer[]{0}), PluginVersion.LIGHT);
		
		this.checkSet("blocking.dispense.chickenEgg.enable", true, PluginVersion.MODERATE);
		this.checkSet("blocking.dispense.chickenEgg.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.MODERATE);
		this.checkSet("blocking.dispense.chickenEgg.dispenseSnowball", true, PluginVersion.MODERATE);
		
		this.checkSet("blocking.dispense.expBottle.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.dispense.expBottle.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
		
		this.checkSet("blocking.dispense.fireCharge.enable", true, PluginVersion.FULL);
		this.checkSet("blocking.dispense.fireCharge.ignoredWorlds", Arrays.asList(new String[]{"ExampleWorld"}), PluginVersion.FULL);
	}

	@Override
	public String getName()
	{
		return "Config.yml";
	}
}
