package me.goosemonkey.NoSpawnEggsV2;

import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockDispenseEvent;

/**
 * Currently covers: XP Bottles, Fire Charges
 * Will cover as of 1.3: Boats, Minecarts, Water?, Lava?
 */
public class ListenerDispenserMisc implements Listener
{
	@EventHandler
	public void onDispense(BlockDispenseEvent event)
	{
		MiscTypeDispense type = this.getTypeFromItemId(event.getItem().getTypeId());
		
		if (type == MiscTypeDispense.NONE)
			return;
		
		if (!NoSpawnEggs.getMainConfig().getBoolean("blocking.dispense." + type.config + ".enable", true))
			return;
		
		if (NoSpawnEggs.getMainConfig().getStringList("blocking.dispense." + type.config + ".ignoredWorlds") != null)
			if (NoSpawnEggs.getMainConfig().getStringList("blocking.dispense." + type.config + ".ignoredWorlds").contains(event.getBlock().getWorld().getName()))
				return;

		event.setCancelled(true);
	}
	
	public MiscTypeDispense getTypeFromItemId(int id)
	{
		switch (id)
		{
		case 384: return MiscTypeDispense.EXPBOTTLE;
		case 385: return MiscTypeDispense.FIRECHARGE;
		default: return MiscTypeDispense.NONE;
		}
	}
	
	enum MiscTypeDispense
	{
		EXPBOTTLE("expBottle"),
		FIRECHARGE("fireCharge"),
		NONE("");
		
		MiscTypeDispense(String config)
		{
			this.config = config;
		}
		
		String config = "";
	}
}
