package me.goosemonkey.NoSpawnEggsV2;

import me.goosemonkey.NoSpawnEggsV2.ListenerPlayerSpawnEgg.MobType;

import org.bukkit.World;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockDispenseEvent;

public class ListenerDispenserSpawnEgg implements Listener
{
	@EventHandler
	public void onDispense(BlockDispenseEvent event)
	{
		if (event.getItem().getTypeId() != 383)
			return;
		
		if (!NoSpawnEggs.getMainConfig().getBoolean("blocking.dispense.spawnEggs.enable", true))
			return;
		
		MobType type = ListenerPlayerSpawnEgg.getMobTypeFromId(event.getItem().getDurability());
		
		if (ListenerDispenserSpawnEgg.shouldSpawnBeBlocked(type, event.getBlock().getWorld()))
		{
			event.setCancelled(true);
		}
	}
	
	static boolean shouldSpawnBeBlocked(MobType type, World world)
	{
		FileConfiguration config = NoSpawnEggs.getMainConfig();
		
		if (config.getIntegerList("blocking.dispense.spawnEggs." + world.getName() + ".blockedIds") != null)
			if (config.getIntegerList("blocking.dispense.spawnEggs." + world.getName() + ".blockedIds").contains(type.getEntityId()))
				return true;
					
		if (config.getIntegerList("blocking.dispense.spawnEggs." + world.getName() + ".allowedIds") != null)
			if (config.getIntegerList("blocking.dispense.spawnEggs." + world.getName() + ".allowedIds").contains(type.getEntityId()))
				return false;
		
		if (config.isBoolean("blocking.dispense.spawnEggs." + world.getName() + "." + type.getCategory().name().toLowerCase()))
			return config.getBoolean("blocking.dispense.spawnEggs." + world.getName() + "." + type.getCategory().name().toLowerCase());
		
		
		if (config.getIntegerList("blocking.dispense.spawnEggs." + ListenerPlayerSpawnEgg.globalName + ".blockedIds") != null)
			if (config.getIntegerList("blocking.dispense.spawnEggs." + ListenerPlayerSpawnEgg.globalName + ".blockedIds").contains(type.getEntityId()))
				return true;
					
		if (config.getIntegerList("blocking.dispense.spawnEggs." + ListenerPlayerSpawnEgg.globalName + ".allowedIds") != null)
			if (config.getIntegerList("blocking.dispense.spawnEggs." + ListenerPlayerSpawnEgg.globalName + ".allowedIds").contains(type.getEntityId()))
				return false;
		
		if (config.isBoolean("blocking.dispense.spawnEggs." + ListenerPlayerSpawnEgg.globalName + "." + type.getCategory().name().toLowerCase()))
			return config.getBoolean("blocking.dispense.spawnEggs." + ListenerPlayerSpawnEgg.globalName + "." + type.getCategory().name().toLowerCase());
		
		return false;
	}
}
