package me.goosemonkey.NoSpawnEggsV2;

import org.bukkit.ChatColor;
import org.bukkit.GameMode;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;

/**
 * Currently covers: XP Bottles, Ender eyes/pearls, Boats, Minecarts
 */
public class ListenerPlayerMisc implements Listener
{
	@EventHandler
	public void onInteract(PlayerInteractEvent event)
	{
		if (event.getAction() != Action.RIGHT_CLICK_AIR && event.getAction() != Action.RIGHT_CLICK_BLOCK)
			return;
		
		MiscType type = this.getTypeFromItemId(event.getPlayer().getItemInHand().getTypeId());
		
		if (type == MiscType.NONE)
			return;
		
		if (NoSpawnEggs.hasPermission(event.getPlayer(), "nse." + type.perm + "." + event.getPlayer().getGameMode().name().toLowerCase()))
			return;
		
		if (!NoSpawnEggs.getMainConfig().getBoolean("blocking." + type.config + ".enable", true))
			return;
		
		if (NoSpawnEggs.getMainConfig().getBoolean("blocking." + type.config + ".onlyBlockCreative", false) && event.getPlayer().getGameMode() == GameMode.SURVIVAL)
			return;
		
		if (NoSpawnEggs.getMainConfig().getStringList("blocking." + type.config + ".ignoredWorlds") != null)
			if (NoSpawnEggs.getMainConfig().getStringList("blocking." + type.config + ".ignoredWorlds").contains(event.getPlayer().getWorld().getName()))
				return;
		
		event.setCancelled(true);
		
		event.getPlayer().sendMessage(ChatColor.GOLD + NoSpawnEggs.getLocaleConfig().getString("message.no" + type.locale + "Perms", "You don't have permission."));
	}
	
	public MiscType getTypeFromItemId(int id)
	{
		switch (id)
		{
		case 384: return MiscType.EXPBOTTLE;
		case 381: return MiscType.ENDEREYE;
		case 368: return MiscType.ENDERPEARL;
		case 333: return MiscType.BOAT;
		case 328: return MiscType.MINECART;
		case 342: return MiscType.MINECART;
		case 343: return MiscType.MINECART;
		default: return MiscType.NONE;
		}
	}
	
	enum MiscType
	{
		EXPBOTTLE("expbottle", "expBottle", "ExpBottle"),
		ENDEREYE("ender.eye", "enderEye", "EnderEye"),
		ENDERPEARL("ender.pearl", "enderPearl", "EnderPearl"),
		BOAT("boat", "boat", "Boat"),
		MINECART("minecart", "minecart", "Minecart"),
		NONE("", "", "");
		
		MiscType(String perm, String config, String locale)
		{
			this.perm = perm;
			this.config = config;
			this.locale = locale;
		}
		
		String perm = "";
		String config = "";
		String locale = "";
	}
}
